import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 17.08.2008
  * @author Daniel Garmann
  */

public class Gui extends JFrame {
  // Anfang Attribute
  private JTextField jTextField1 = new JTextField();
  private JButton jButton1 = new JButton();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JScrollPane jScrollPane1 = new JScrollPane();
    private JTextArea jTextArea1 = new JTextArea("");
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super (title);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    int frameWidth = 300;
    int frameHeight = 618;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jTextField1.setBounds(120, 480, 113, 24);
    jTextField1.setText("5");
    cp.add(jTextField1);
    jButton1.setBounds(40, 520, 179, 25);
    jButton1.setText("Erstelle Bezahlmgl.");
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    jLabel1.setBounds(48, 480, 49, 16);
    jLabel1.setText("n =");
    jLabel1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel1);
    jLabel2.setBounds(16, 8, 231, 16);
    jLabel2.setText("Mglichkeiten der Bezahlung:");
    jLabel2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel2);
    jScrollPane1.setBounds(8, 32, 273, 425);
    cp.add(jScrollPane1);
    jTextArea1.setText("");
    jTextArea1.setBounds(22, 30, 185, 89);
    jScrollPane1.setViewportView(jTextArea1);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  void ausgabe(int n, String zeichenkette)
{
  if (n == 0)
    jTextArea1.append(zeichenkette+"\n");
             // In TextArea wird eine neue Zeile, die bis hier
             // zusammengesetzte Zeichenkette, ausgegeben.
             //              REKURSIONSANKER
  else {
             // Es stehen noch Zeiteinheiten zur Verfgung,
             // also muss die Rekursion neu gestartet werden.
           ausgabe(n-1, zeichenkette+ "K-");

           if (n >= 2) {
             ausgabe(n-2, zeichenkette+ "M-");
           }
           if (n >= 4) {
             ausgabe(n-4, zeichenkette+ "G-");
           }
  }
}

  void ausgabe(int n, int w, String zeichenkette)
  {
    if (n == 0)
      jTextArea1.append(zeichenkette+"\n");
             // In TextArea wird eine neue Zeile, die bis hier
             // zusammengesetzte Zeichenkette, ausgegeben.
             //              REKURSIONSANKER
    else {
      if (zeichenkette.length() > 0) zeichenkette = zeichenkette + "+";
               // Es stehen noch Zeiteinheiten zur Verfgung,
               // also muss die Rekursion neu gestartet werden.
      if ((n >= 4) && (w >= 4)) ausgabe(n-4, 4, zeichenkette+ "G");
      if ((n >= 2) && (w >= 2)) ausgabe(n-2, 2, zeichenkette+ "M");
      if ((n >= 1) && (w >= 1)) ausgabe(n-1, 1, zeichenkette+ "K");
    }
  }
  
  public int moeglichkeiten(int n) {
    if (n <= 1) return 1;
    else if (n == 2) return 2;
    else if (n == 3) return 3;
    else return moeglichkeiten(n-1)+moeglichkeiten(n-2)+moeglichkeiten(n-4);
  }

  public void jButton1_ActionPerformed(ActionEvent evt) {
    jTextArea1.setText("");
    ausgabe(Integer.parseInt(jTextField1.getText()),"");
    jTextArea1.append("Anzahl der Mglichkeiten: "+moeglichkeiten(Integer.parseInt(jTextField1.getText())));
  }

  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Gui");
  }
}
